/*  KRunning - DBConnection.cpp
 *  Copyright (C) 2002 by Andreas Scherf
 *  Begin Sam Mai 11 2002 write to scherfa@web.de if you found a bug.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "DBConnection.h"

#include <iostream>   

using namespace std;

bool eventObj::save() {
    return save(false);
}

bool eventObj::save(bool update) {
    char *zErrMsg=0;
    if (dbconn->isConnected()) {
        if (dbconn->getDBType()==DBConnection::SQLite) {
            if (update) {
                sqlite_exec_printf(dbconn->getSQLiteDB(), "UPDATE events SET eventname='%q',startnumberframes='%q',starttime_0='%q',distance=%d WHERE number=%d" , 0, 0, 0,name.latin1(),startnumberframes.latin1(),starttime.toString("hh:mm:ss.zzz" ).latin1(),distance,number);
                return TRUE;
            }  else {
                sqlite_exec_printf(dbconn->getSQLiteDB(),
                                   "INSERT INTO events (number,eventname,startnumberframes,starttime_0,distance) VALUES(NULL,'%q','%q','%q',%d)",
                                   0, 0, &zErrMsg, name.latin1(),startnumberframes.latin1(),starttime.toString("hh:mm:ss.zzz" ).latin1(),distance);
                number=sqlite_last_insert_rowid(dbconn->getSQLiteDB());
                return TRUE;
            } // UPDATE
        } else {
            QSqlCursor cur( "events" );
            QSqlRecord *buffer;
            if (update) {
                cur.select(QString("number='%1'").arg(number));
                cur.next();
                buffer=cur.primeUpdate();
            } else {
                buffer=cur.primeInsert();
                QSqlQuery q( "select nextval('events_number_seq');" );
                if ( q.next() ) {
                    buffer->setValue( "number", q.value(0) );
                    number=q.value(0).toInt();
                }
            }
            buffer->setValue( "eventname", name );
            buffer->setValue( "startnumberframes", startnumberframes);
            buffer->setValue( "starttime_0", starttime.toString("hh:mm:ss.zzz" ));
            buffer->setValue( "distance", distance );
            if (update) {
                cur.update();
            }  else   {
                cur.insert();
                //               cerr <<        cur.lastQuery() << endl;
            } //UPDATE
            return TRUE;
        }
    }
    return FALSE;
}

bool teamObj::save() {
    return save(false);
}

bool teamObj::save(bool update) {
    if (dbconn->isConnected()) {
        if (dbconn->getDBType()==DBConnection::SQLite) {
            if (update) {
                sqlite_exec_printf(dbconn->getSQLiteDB(), "UPDATE teams SET teamname='%q' WHERE number=%d" , 0, 0, 0,name.latin1(),number);
                return TRUE;
            }  else {
                sqlite_exec_printf(dbconn->getSQLiteDB(), "INSERT INTO teams (teamname) VALUES('%q')",  0, 0, 0, name.latin1());
                // number,NULL
                number=sqlite_last_insert_rowid(dbconn->getSQLiteDB());
                return TRUE;
            } // UPDATE
        } else {
            QSqlCursor cur("teams");
            QSqlRecord * buffer;
            if (update) {
                cur.select(QString("number='%1'").arg(number));
                cur.next();
                buffer=cur.primeUpdate();
            } else {
                buffer=cur.primeInsert();
                QSqlQuery q( "select nextval('teams_number_seq');" );
                if ( q.next() ) {
                    buffer->setValue( "number", q.value(0) );
                    number=q.value(0).toInt();
                }
            }
            buffer->setValue("teamname",name);
            if (update) {
                cur.update();
            }  else   {
                cur.insert();
                cerr <<        cur.lastQuery() << endl;
                return TRUE;
            } //UPDATE
        }
    }
    return FALSE;
}

bool runnerObj::save() {
    return save(false);
}
bool runnerObj::save(bool update) {
    char *zErrMsg=0;
    if (dbconn->isConnected()) {
        if (dbconn->getDBType()==DBConnection::SQLite) {
            if (update) {
                sqlite_exec_printf(dbconn->getSQLiteDB(), "UPDATE runner SET number=%d,surname='%q',forename='%q',birthday=%d,sex=%d,event=%d,team=%d,street='%q',city='%q',plz=%d,nation='%q',chipnum='%q',state=%d,comment='%q',place_total=%d,place_class=%d,place_sex=%d,place_team=%d,place_nation=%d WHERE number=%d"
                                   ,  0, 0, &zErrMsg,newnumber,surname.latin1(),forename.latin1(),birthday,sex,event,team,street.latin1(),city.latin1(),plz,nation.latin1(),chipnum.latin1(),state,comment.latin1(),placetotal,placeclass,placesex,placeteam,placenation,number);
                /*  cerr << zErrMsg << endl;*/
                return TRUE;
            } else {
                sqlite_exec_printf(dbconn->getSQLiteDB(), "INSERT INTO runner (number,surname,forename,birthday,sex,event,team,street,city,plz,nation,chipnum,state,comment,place_total,place_class,place_sex,place_team,place_nation) VALUES(%d,'%q','%q',%d,%d,%d,%d,'%q','%q',%d,'%q','%q',%d,'%q',%d,%d,%d,%d,%d)"
                                   ,  0, 0, &zErrMsg,number, surname.latin1(),forename.latin1(),birthday,sex,event,team,street.latin1(),city.latin1(),plz,nation.latin1(),chipnum.latin1(),state,comment.latin1(),placetotal,placeclass,placesex,placeteam,placenation);
                /* cerr << zErrMsg << endl;*/
                return TRUE;
            }

        } else {
            QSqlCursor cur("runner");
            QSqlRecord * buffer;
            if (update) {
                cur.select(QString("number='%1'").arg(number));
                cur.next();
                buffer=cur.primeUpdate();
            } else {
                buffer=cur.primeInsert();
            }
            buffer->setValue("number", newnumber );
            buffer->setValue("surname",surname);
            buffer->setValue("forename",forename);
            buffer->setValue("birthday",birthday);
            buffer->setValue("sex",sex);
            buffer->setValue("event",event);
            buffer->setValue("team",team);
            buffer->setValue("street",street);
            buffer->setValue("city",city);
            buffer->setValue("plz",plz);
            buffer->setValue("nation",nation);
            buffer->setValue("chipnum",chipnum);
            buffer->setValue("state",state);
            buffer->setValue("comment",comment);
            buffer->setValue("place_total",placetotal);
            buffer->setValue("place_class",placeclass);
            buffer->setValue("place_sex",placesex);
            buffer->setValue("place_team",placeteam);
            buffer->setValue("place_nation",placenation);
            if (update) {
                cur.update();
                //            cerr << cur.lastQuery() << endl;
            }  else   {
                cur.insert();
                //                cerr << cur.lastQuery() << endl;
                return TRUE;
            }
        }
    }
    return FALSE;
}

/** < for sort functions ...
*/
bool operator<(runnerObj &a,runnerObj &b) {
    if (b.runnerbirthday()<a.runnerbirthday()) return true;
    else return false;
}
bool timeObj::save() {
    return save(false);
}

bool timeObj::save(bool update) {
    if (dbconn->isConnected()) {
        if (dbconn->getDBType()==DBConnection::SQLite) {
            if (update) {
                sqlite_exec_printf(dbconn->getSQLiteDB(), "UPDATE times SET event=%d,time='%q' WHERE number=%d" , 0, 0, 0,event,time.toString("hh:mm:ss.zzz" ).latin1(),number);
                return TRUE;
            }  else {
                sqlite_exec_printf(dbconn->getSQLiteDB(), "INSERT INTO times (number,event,time) VALUES(NULL,'%d','%q')",  0, 0, 0, event,time.toString("hh:mm:ss.zzz").latin1());
                number=sqlite_last_insert_rowid(dbconn->getSQLiteDB());
                return TRUE;
            }
        } else {
            QSqlCursor cur("times");
            QSqlRecord * buffer;
            if (update) {
                cur.select(QString("number='%1'").arg(number));
                cur.next();
                buffer=cur.primeUpdate();
            } else {
                buffer=cur.primeInsert();
                QSqlQuery q( "select nextval('times_number_seq');" );
                if ( q.next() ) {
                    buffer->setValue( "number", q.value(0) );
                    number=q.value(0).toInt();
                }
            }
            buffer->setValue("event",event);
            buffer->setValue( "time",time.toString("hh:mm:ss.zzz"));
            if (update) {
                cur.update();
                return TRUE;
            }  else   {
                cur.insert();
                cerr <<        cur.lastQuery() << endl;
                return TRUE;
            }
        }
    }
    return FALSE;
}

QString timeObj::getTimeString(const QString &ts) {
    return time.toString(ts );// Global TIMESTRING ??
}

/** < for sort functions ...
*/
bool operator<(timeObj &a,timeObj &b) {
    if (a.getTime()<b.getTime()) return true;
    else return false;
}

bool runnertimeObj::save() {
    if (dbconn->isConnected()) {
        if (dbconn->getDBType()==DBConnection::SQLite) {
            sqlite_exec_printf(dbconn->getSQLiteDB(), "INSERT INTO runnertimes (number,runner,event,time) VALUES(NULL,%d,%d,%d)",  0, 0, 0, runner,event,time);
            number=sqlite_last_insert_rowid(dbconn->getSQLiteDB());
            return TRUE;
        } else {
            QSqlCursor cur("runnertimes");
            QSqlRecord * buffer=cur.primeInsert();
            QSqlQuery q("select nextval('runnertimes_number_seq');");
            if (q.next() ) {
                buffer->setValue("number",q.value(0));
                number=q.value(0).toInt();
            }
            buffer->setValue("runner",runner);
            buffer->setValue("event",event);
            buffer->setValue("time",time);
            cur.insert();
            return TRUE;
        }           }
    return FALSE;
}

bool documentObj::save() {
    return save(false);
}


bool documentObj::save(bool update) {
    char *zErrMsg=0;
    if (dbconn->isConnected()) {
        if (dbconn->getDBType()==DBConnection::SQLite) {
            if (update) {
                sqlite_exec_printf(dbconn->getSQLiteDB(), "UPDATE documents SET name='%q' ,size='%q' WHERE number=%d" , 0, 0, 0,name.latin1(),size.latin1(),number);
                return TRUE;
            }  else {
                sqlite_exec_printf(dbconn->getSQLiteDB(),
                                   "INSERT INTO documents (number,name,size) VALUES(NULL,'%q','%q')",
                                   0, 0, &zErrMsg, name.latin1(),size.latin1());
                number=sqlite_last_insert_rowid(dbconn->getSQLiteDB());
                cerr << zErrMsg << endl;
                return TRUE;
            } // UPDATE
        } else {
            QSqlCursor cur( "documents" );
            QSqlRecord *buffer;
            if (update) {
                cur.select(QString("number='%1'").arg(number));
                cur.next();
                buffer=cur.primeUpdate();
            } else {
                buffer=cur.primeInsert();
                QSqlQuery q( "select nextval('documents_number_seq');" );
                if ( q.next() ) {
                    buffer->setValue( "number", q.value(0) );
                    number=q.value(0).toInt();
                }
            }
            buffer->setValue( "name", name );
            buffer->setValue( "size", size );
            if (update) {
                cur.update();
            }  else   {
                cur.insert();
                //               cerr <<        cur.lastQuery() << endl;
            } //UPDATE
            return TRUE;
        }
    }
    return FALSE;
}


bool documentframeObj::save() {
    if (dbconn->isConnected()) {
        if (dbconn->getDBType()==DBConnection::SQLite) {
            sqlite_exec_printf(dbconn->getSQLiteDB(), "INSERT INTO documentframes (number,document,frame) VALUES(NULL,%d,%d,%d)",  0, 0, 0, document,frame);
            number=sqlite_last_insert_rowid(dbconn->getSQLiteDB());
            return TRUE;
        } else {
            QSqlCursor cur("documentframes");
            QSqlRecord * buffer=cur.primeInsert();
            QSqlQuery q("select nextval('documentframes_number_seq');");
            if (q.next() ) {
                buffer->setValue("number",q.value(0));
                number=q.value(0).toInt();
            }
            buffer->setValue("document",document);
            buffer->setValue("frame",frame);
            cur.insert();
            return TRUE;
        }           }
    return FALSE;
}

//--------------------------------

DBConnection::DBConnection(){
    cerr << "DBConnection called" << endl;
    krunningConfig = KGlobal::config();
    krunningConfig->setGroup( "Database" );
    if (krunningConfig->readEntry("Driver","")=="SQLITE") {
        dbtype=SQLite;
        defaultDB=0;
        dbname=QString();
        db=NULL;
    }  else {
        defaultDB = QSqlDatabase::addDatabase(krunningConfig->readEntry("Driver","QPSQL7"));
        dbtype=Unknown;
    }
    connected=FALSE;
}

DBConnection::~DBConnection(){
    cerr << "~DBConnection called" << endl;
    disconnect();
}

void DBConnection::disconnect() {
    if (!connected) return;
    if (dbtype == SQLite) {
        sqlite_close(db);
    } else {
        defaultDB->close();
        connected=FALSE;
    }
}

void DBConnection::setDefaultDB(const QString &driver) {
    /* From QT3 Doku.
    The currently available drivers are:

    QODBC3 - ODBC (Open Database Connectivity) Driver
    QOCI8 - Oracle Call Interface Driver
    QPSQL7 - PostgreSQL v6.x and v7.x Driver
    QTDS7 - Sybase Adaptive Server and Microsoft SQL Server Driver
    QMYSQL3 - MySQL Driver

    Note that additional 3rd party drivers can be loaded dynamically.
    */
    if (driver=="SQLITE") {
        dbtype=SQLite;
        defaultDB=0;
        dbname=QString();
    } else {
        defaultDB = QSqlDatabase::addDatabase( driver );
        dbtype=Unknown;
    }

}

void DBConnection::connect(const QString &databasename,const QString &username,const QString &dbpasswd,const QString &dbhost) {
    if ( defaultDB ) {
        defaultDB->setDatabaseName( databasename);
        defaultDB->setUserName( username );
        defaultDB->setPassword( dbpasswd );
        defaultDB->setHostName( dbhost );

        if (!defaultDB->isOpen()) {
            connected=defaultDB->open();
        } else {
            connected=TRUE;
        }
    }
}

void DBConnection::connectExternalDb() {

    krunningConfig->setGroup( "Database" );
    cerr << "setDBParameters" << endl;

    if ( defaultDB ) {
        defaultDB->setDatabaseName(krunningConfig->readEntry( "Databasename","lauf" ));
        defaultDB->setUserName(krunningConfig->readEntry( "Username","" ));
        defaultDB->setPassword(krunningConfig->readEntry( "Password","" ));
        defaultDB->setHostName(krunningConfig->readEntry( "Hostname","localhost" ));
        //        defaultDB->setPort(krunningConfig->readEntry( "Port","5432" ).toInt(&port,10));
        if (!defaultDB->isOpen()) {
            connected=defaultDB->open();
        } else {
            connected=TRUE;
        }
        if ( ! connected ) {
            qWarning( "Failed to open default database: " +  defaultDB->lastError().driverText() );
            //            qWarning( defaultDB->lastError().databaseText() );

        }
    }

}
void DBConnection::connectSqlite(const QString &filename) {

    char *zErrMsg=0;

    krunningConfig->setGroup( "Database" );
    if (dbtype==SQLite) {

        if (!filename.isEmpty()) {
            db = sqlite_open(filename , 0, &zErrMsg);
            dbname=QString(filename.section( '/', -1 ));

        } else {
            db = sqlite_open(krunningConfig->readEntry( "Databasename","default.db"), 0, &zErrMsg);
            dbname=krunningConfig->readEntry( "Databasename","default.db");
        }
        if (db) connected=true;
        else connected=false;
    }
}
void DBConnection::connect() {
    connect("");
}


void DBConnection::connect(const QString &filename){
    if ( defaultDB ) {
        connectExternalDb();
    } else {
        connectSqlite(filename);
    }
}


void DBConnection::startTransaction() {
    if (dbtype==SQLite) return;
    if (connected) {
        defaultDB->transaction();
    }
}

void DBConnection::commitTransaction() {
    if (dbtype==SQLite) return;
    if (connected) {
        defaultDB->commit();
    }
}




bool DBConnection::isConnected() {
    return connected;
}

QSqlDatabase *DBConnection::getDatabase() {
    return defaultDB;
}

void freeres(char **res)
{
    for (int i=0;!(res[i]);i++)
    {
        delete (res[i]);
        res[i]=0;
    }
}


QStringList DBConnection::getSqliteTables() {
    char **res;
    int ntab,ncol;
    QStringList result;
    if (!connected) return result;

    int err=sqlite_get_table (db,"SELECT name FROM sqlite_master WHERE type='table' ORDER BY name;", &res,&ntab,&ncol,NULL);
    if (SQLITE_OK == err && ntab > 0 )	{
        for (int i=0 ;i<ntab;i++) {
            result.append(res[i]);
        }
    } else	{
        qDebug ("could not get list of tables: %d",err);
    }
    freeres (res);

    return result;
}

bool DBConnection::testTables() {
    int tablesum=0;
    if (!connected) return FALSE;

    if (dbtype==SQLite) {
        tablesum=getSqliteTables().size();
    } else {
        QStringList list = defaultDB->tables();
        QStringList::Iterator it = list.begin();
        while( it != list.end() ) {
            //     cerr << ( *it )<< endl;
            tablesum++;
            ++it;
        }
    }
    if (tablesum>=6)
        return  TRUE;
    else
        return FALSE;
}

bool DBConnection::createEmptyTables() {
    if (connected) {
        // Teams
        if (dbtype==SQLite) {
            char *zErrMsg=0;
            sqlite_exec(db, "create table teams (number INTEGER PRIMARY KEY, teamname text UNIQUE)", 0, 0, &zErrMsg);
            sqlite_exec(db, "create table events (number INTEGER PRIMARY KEY, eventname text,startnumberframes text,starttime_0 text,starttime_1 text,distance int,document int)", 0, 0, &zErrMsg);
            sqlite_exec(db, "create table times (number INTEGER PRIMARY KEY, time text,event int)", 0, 0, &zErrMsg);
            // Version 2.7.1 don't support foreign keys .. hope that it will bring it soon
            sqlite_exec(db, "create table runner (number INTEGER PRIMARY KEY, surname text,forename text,birthday int2,sex int2,event REFERENCES events(number) MATCH PARTIAL,team REFERENCES teams(number) MATCH PARTIAL,street text,city text,plz int, nation text,chipnum text, state int2,comment text,place_total int2,place_class int2, place_sex int2, place_team int2,place_nation int2)", 0, 0, &zErrMsg);
            sqlite_exec(db, "create table runnertimes (number INTEGER PRIMARY KEY,runner int references runner,event int references events,time int references times)", 0, 0, &zErrMsg);
            sqlite_exec(db, "create table documents (number INTEGER PRIMARY KEY, name text,size text)", 0, 0, &zErrMsg);
            sqlite_exec(db, "create table frames (number INTEGER PRIMARY KEY, textline text,picture text,yposition int,xposition int, align int,font text,direction int,layer int)", 0, 0, &zErrMsg);
            sqlite_exec(db, "create table documentframes (number INTEGER PRIMARY KEY, document int references documents,frame int references frames)", 0, 0, &zErrMsg);

            cerr << "Creating tables :" << zErrMsg << endl;
        } else {
            QSqlQuery query,statement;
            if (!query.exec ("select * from teams")) {
                statement.exec ("drop table teams");
                statement.exec ("create table teams (number SERIAL primary key,teamname text)");
                //            statement.exec ("create unique index team_num on team (number,teamname)");
                //            statement.exec ("create unique index verein_name on vereine (v_name)");
                statement.exec ("grant ALL on teams to public");
                statement.exec("grant ALL on  teams_number_seq to public");
            }

            // Running Events
            if (!query.exec ("select * from events")) {
                statement.exec ("drop table events");
                statement.exec ("create table events (number SERIAL primary key,eventname text,startnumberframes text,starttime_0 text, starttime_1 text,distance int,document int)");
                //  statement.exec ("create unique index event_num on events (number)");
                statement.exec ("grant ALL on events to public");
                statement.exec("grant ALL on  events_number_seq to public");
            }
            // Times
            if (!query.exec ("select * from times")) {
                statement.exec ("drop table times");

                statement.exec ("create table times (number SERIAL primary key,time text,event int references events)");
                // statement.exec ("create index time_num on times (number)");
                statement.exec ("grant ALL on times to public");
                statement.exec("grant ALL on  times_number_seq to public");

            }

            // Runner
            if (!query.exec ("select * from runner")) {
                statement.exec ("drop table runner");
                statement.exec ("create table runner (number int primary key, surname text,forename text,birthday int2,sex int2,event int references events,team int references teams,street text,city text,plz int, nation text,chipnum text, state int2,comment text,place_total int2,place_class int2, place_sex int2, place_team int2,place_nation int2)");
                //          statement.exec ("create unique index runner_num on runner (number)");
                statement.exec ("grant ALL on runner to public");
            }
            // Runnertimes
            if (!query.exec ("select * from runnertimes")) {
                statement.exec ("drop table runnertimes");
                statement.exec ("create table runnertimes (number SERIAL primary key,runner int references runner,event int references events,time int references times)");
                //      statement.exec ("create unique index runnertimes_num on runnertimes (number)");
                statement.exec ("grant ALL on runnertimes to public");
                statement.exec("grant ALL on  runnertimes_number_seq to public");
            }

            if (!query.exec ("select * from documents")) {
                statement.exec ("drop table documents");
                statement.exec ("create table documents (number SERIAL primary key,name text,size text)");
                statement.exec ("grant ALL on documents to public");
                statement.exec("grant ALL on  documents_number_seq to public");
            }
            if (!query.exec ("select * from frames")) {
                statement.exec("drop table frames");
                statement.exec("create table frames (number SERIAL primary key,textline text,picture text,yposition int,xposition int, align int,font text,direction int,layer int)");
                statement.exec("grant ALL on frames to public");
                statement.exec("grant ALL on frames_number_seq to public");
            }

            if (!query.exec("select * from  documentframes")) {
                statement.exec ("drop table documentframes");
                statement.exec("create table documentframes (number SERIAL primary key,document int references documents,frame int references frames)");
                statement.exec("grant ALL on documentframes to public");
                statement.exec("grant ALL on documentframes_number_seq to public");
            }

            // Statistic
            if (!query.exec ("select * from statistics")) {
                statement.exec ("drop view statistics");
                statement.exec ("create view statistics as select COUNT(*) from runner");
                cerr <<                statement.lastError().databaseText()<<endl;
                statement.exec ("grant ALL on statistics to public");
            }
        }

    }// if connected
    return TRUE;
}


void DBConnection::query(QString &q) {

    if (connected) {
        QSqlQuery query( q, defaultDB );
        if ( query.isActive() ) {
            cout << query.numRowsAffected () << endl;
            while ( query.next() ) {

                // cout <<   query.value(0).toString() << ", " << query.value(1).toString() << endl;
            } }
    }

}
/**
@param if name ist true it resturns the surnames otherwise the forenames
@returns a String list with all names (for the completion mode)
*/
QStringList DBConnection::getNameList(bool type) {
    QStringList result=QStringList("");
    QString name=QString();
    if (connected) {
        if (type) {
            name=QString("surname");
        } else {
            name=QString("forename");
        }
        if (dbtype==SQLite) {
            char **res;
            int nRow,nColumns;
            sqlite_get_table_printf(db,"select distinct %q from runner",&res,&nRow,&nColumns,NULL,name.latin1());
            if (nRow > 0) {
                for (int i=(nColumns);i<((nRow+1)*nColumns);i+=nColumns) {
                    result.append(QString(res[i]));
                }
                sqlite_free_table(res);
            }
        } else {
            QSqlQuery query(QString("select distinct %1 from runner").arg(name));
            while (query.next()) {
                result.append(query.value(0).toString());
            }//while
        } //else
    } //connected
    return result;
}

QStringList DBConnection::getStartNumberFrames() {
    QStringList result=QStringList("");
    if (connected) {
        if (dbtype==SQLite) {
            char **res;
            int nRow,nColumns;
            sqlite_get_table(db,"select number,startnumberframes from events",&res,&nRow,&nColumns,NULL);
            if (nRow > 0) {
                for (int i=(nColumns);i<((nRow+1)*nColumns);i+=nColumns) {
                    result.append(QString(res[i])+","+QString(res[i+1]));
                }
                sqlite_free_table(res);
            }
        } else {
            QSqlQuery query("select number,startnumberframes from events");
            while (query.next()) {
                result.append(query.value(0).toString()+","+query.value(1).toString());
            }//while
        } //else
    } //connected
    return result;
}

QString DBConnection::getTeamNameByNumber (int number) {
    QString result;
    if (connected) {
        if (dbtype==SQLite) {
            char **res;
            int nRow,nColumns;
            sqlite_get_table_printf(db,"select teamname from teams where number = %d",&res,&nRow,&nColumns,NULL,number);

            if (nRow > 0) {

                for (int i=(nColumns);i<((nRow+1)*nColumns);i+=nColumns) {
                    result.append(QString(res[i]));
                }
                sqlite_free_table(res);
            }
        } else {
            QSqlQuery query(QString("select teamname from teams where number = '%1'").arg(number));
            if (query.next()) {
                result.append(query.value(0).toString());
            }else { // Now Rows returned.
                result.append(""); // maybe no team could be returned ??
            }
        }
    }
    return result;
}

QString DBConnection::getEventNameByNumber (int number) {
    QString result;
    if (connected) {
        if (dbtype==SQLite) {
            char **res;
            int nRow,nColumns;
            sqlite_get_table_printf(db,"select eventname from events where number = %d",&res,&nRow,&nColumns,NULL,number);

            if (nRow > 0) {

                for (int i=(nColumns);i<((nRow+1)*nColumns);i+=nColumns) {
                    result.append(QString(res[i]));
                }
                sqlite_free_table(res);
            }
        } else {
            QSqlQuery query(QString("select eventname from events where number = '%1'").arg(number));
            if (query.next()) {
                result.append(query.value(0).toString());
            } else { // No Rows returned.
                result.append("");
            }
        }
    }
    return result;
}

eventObj DBConnection::getEventByNumber (int number) {
    eventObj result=eventObj();
    if (connected) {         //int num,const QString& nm , int mn,int mx,int stime,int dist )
        if (dbtype==SQLite) {
            char **res;
            int nRow,nColumns;
            sqlite_get_table_printf(db,"select eventname,startnumberframes,starttime_0,distance from events where number = %d",&res,&nRow,&nColumns,NULL,number);

            if (nRow > 0) {

                for (int i=(nColumns);i<((nRow+1)*nColumns);i+=nColumns) {
                    result= eventObj(number,QString(res[i]),QString(res[i+1]),QTime::fromString(QString(res[i+2])),QString(res[i+3]).toInt());
                }
                sqlite_free_table(res);
            }
        } else {
            QSqlQuery query(QString("select * from events where number = '%1'").arg(number));
            if (query.next()) {
                result=eventObj(query.value(0).toInt(),query.value(1).toString(),
                                query.value(2).toString(),QTime::fromString(query.value(3).toString()),query.value(4).toInt());
            } else { // No Rows returned.

            }
        }
    }
    return result;
}

eventObj DBConnection::getEventByName (const QString & name) {
    eventObj result=eventObj();
    if (connected) {         //int num,const QString& nm , int mn,int mx,int stime,int dist )
        if (dbtype==SQLite) {
            char **res;
            int nRow,nColumns;
            sqlite_get_table_printf(db,"select number,startnumberframes,starttime_0,distance from events where eventname = '%q'",&res,&nRow,&nColumns,NULL,name.latin1());

            if (nRow > 0) {

                for (int i=(nColumns);i<((nRow+1)*nColumns);i+=nColumns) {
                    result= eventObj(QString(res[i]).toInt(),name,QString(res[i+1]),QTime::fromString(QString(res[i+2])),QString(res[i+3]).toInt());
                }
                sqlite_free_table(res);
            }
        } else {
            QSqlQuery query(QString("select * from events where eventname = '%1'").arg(name));
            if (query.next()) {
                result=eventObj(query.value(0).toInt(),query.value(1).toString(),
                                query.value(2).toString(),QTime::fromString(query.value(3).toString()),query.value(4).toInt());
            } else { // No Rows returned.

            }
        }
    }
    return result;
}

/** This funktion searches the event from a startnumber but there must be frames to get the event !!
@return eventObj
*/

eventObj DBConnection::getEventByStartnumber(int number) {
    eventObj result=eventObj();
    QStringList frames= getStartNumberFrames();
    int eventnumber=-1;
    for ( QStringList::Iterator it = frames.begin(); it != frames.end(); ++it ) {
        QString outerframe (*it);
        eventnumber= outerframe.section(',',0,0).toInt();
        QString inner=outerframe.section(',',1,1); // The inner frames
        QStringList framelist = QStringList::split( ';',inner );
        for ( QStringList::Iterator it = framelist.begin(); it != framelist.end(); ++it ) {
            QString frame (*it);
            if (frame.section('-',0,0).toInt()<=number && frame.section('-',1,1).toInt()>=number) {
                return getEventByNumber(eventnumber);
            }
        }
    }
    return result;
}
/** This functions tests if a block is used in another event.
@return eventnumber in which the block was found.
*/
int DBConnection::testStartNumberFrame(QString & frame) {
    int result=-1; // this value say ok if the frame is ok.
    int upper,lower;
    lower=frame.section('-',0,0).toInt();
    upper=frame.section('-',1,1).toInt();
    EventList events=getEventList();
    EventList::Iterator it;
    for (it=events.begin();it!=events.end();++it) {
        QStringList framelist = QStringList::split( ';',(*it).getStartnumberFrames() );
        for ( QStringList::Iterator sit = framelist.begin(); sit != framelist.end(); ++sit ) {
            QString frame (*sit);
            for (int number=lower;number<=upper;number++) {
                for (int test=frame.section('-',0,0).toInt();test<=frame.section('-',1,1).toInt();test++) {
                    if (test==number)  return (*it).getEventNumber();
                }
            }
        }
    }
    return result;
}



/**
lists all runners from the given event number
  @return RunnerList
*/

DBConnection::RunnerList DBConnection::getRunnerListByEvent (int event,bool join) {
    QString filter,querystring;
    RunnerList result;
    /*  ("select runner.number,name,vorname,vereine.v_name,geb_jahr, runner.sex,%s "
    	   " place_total ,place_class ,place_sex,place_team,place_nation " "from runner, vereine %s" "where runner.verein = vereine.number " "%s %s %s", show_select_string, show_from_string, show_time_string, run_number_state, sorting_string);
      */
    if (connected) {
        if (dbtype==SQLite) {
            char **res;
            int nRow,nColumns;
            char *zErrMsg=0;
            if (join == false ) {
                sqlite_get_table_printf(db,"select number,surname,forename,birthday,sex,event,team,street,city,plz,nation,chipnum,state,comment,place_total,place_class,place_sex,place_team,place_nation from runner where event = %d",&res,&nRow,&nColumns,&zErrMsg,event);

                if (nRow > 0) {

                    for (int i=(nColumns);i<((nRow+1)*nColumns);i+=nColumns) {
                        result.append( runnerObj(QString(res[i]).toInt(),QString(res[i+1]),QString(res[i+2]),
                                                 QString(res[i+3]).toInt(),((runnerObj::SexNum)QString(res[i+4]).toInt()),QString(res[i+5]).toInt(),QString(res[i+6]).toInt(),
                                                 QString(res[i+7]),QString(res[i+8]),QString(res[i+9]).toInt(),
                                                 QString(res[i+10]),QString(res[i+11]),((runnerObj::StateNum)QString(res[i+12]).toInt()),QString(res[i+13]),
                                                 QString(res[i+14]).toInt(),QString(res[i+15]).toInt(),QString(res[i+16]).toInt(),QString(res[i+17]).toInt(),QString(res[i+18]).toInt()));
                    }
                    sqlite_free_table(res);
                }
            } else {
                sqlite_get_table_printf(db,"select runner.number,surname,forename,birthday,sex,teams.teamname,street,city,plz,nation,chipnum,state,comment,place_total,place_class,place_sex,place_team,place_nation FROM runner JOIN teams ON ( runner.team = teams.number ) WHERE runner.event =  %d",&res,&nRow,&nColumns,&zErrMsg,event);
                if (nRow > 0) {
                    for (int i=(nColumns);i<((nRow+1)*nColumns);i+=nColumns) {
                        result.append( runnerObj(QString(res[i]).toInt(),QString(res[i+1]),QString(res[i+2]),
                                                 QString(res[i+3]).toInt(),((runnerObj::SexNum)QString(res[i+4]).toInt()),event,QString(res[i+5]),QString(res[i+6]),
                                                 QString(res[i+7]),QString(res[i+8]).toInt(),
                                                 QString(res[i+9]),QString(res[i+10]),((runnerObj::StateNum)QString(res[i+11]).toInt()),QString(res[i+12]),
                                                 QString(res[i+13]).toInt(),QString(res[i+14]).toInt(),QString(res[i+15]).toInt(),QString(res[i+16]).toInt(),QString(res[i+17]).toInt()));
                    }
                    sqlite_free_table(res);
                }
            }
            //cerr << "Error :"<< zErrMsg << endl;// JOIN
        } else {  // SQLite

            if (join == false) {
                QSqlCursor cursor( "runner" );
                filter = QString( "event = '%1' " ).arg( event );
                cursor.select(filter);
                while (cursor.next()) {
                    result.append(runnerObj(cursor.value( "number" ).toInt(),cursor.value( "surname" ).toString(), cursor.value( "forename" ).toString(),
                                            cursor.value( "birthday" ).toInt(),((runnerObj::SexNum)cursor.value( "sex" ).toInt()), cursor.value( "event" ).toInt(),cursor.value( "team" ).toInt(),
                                            cursor.value( "street" ).toString(),cursor.value( "city" ).toString(),cursor.value( "plz" ).toInt(),
                                            cursor.value( "nation" ).toString(),cursor.value( "chipnum" ).toString(),((runnerObj::StateNum)cursor.value( "state" ).toInt()),cursor.value("comment").toString(),
                                            cursor.value("place_total").toInt(),cursor.value("place_class").toInt(),cursor.value("place_sex").toInt(),cursor.value("place_team").toInt(),cursor.value("place_nation").toInt()   ));
                }  // while
            } else { // if join
                querystring = QString( "select runner.number,surname,forename,birthday,sex,teams.teamname,street,city,plz,nation,chipnum,state,comment,place_total,place_class,place_sex,place_team,place_nation from runner,teams where runner.team = teams.number and runner.event = '%1'  " ).arg( event);
                QSqlQuery query(querystring);
                while(query.next()) {
                    result.append(runnerObj(query.value(0).toInt(),query.value(1).toString(),query.value(2).toString(),
                                            query.value(3).toInt(),((runnerObj::SexNum)query.value(4).toInt()),event,query.value(5).toString(),
                                            query.value(6).toString(),query.value(7).toString(),query.value(8).toInt(),
                                            query.value(9).toString(),query.value(10).toString(),((runnerObj::StateNum)query.value(11).toInt()),query.value(12).toString(),
                                            query.value(13).toInt(),query.value(14).toInt(),query.value(15).toInt(),query.value(16).toInt(),query.value(17).toInt()   ));
                }// while
            } // else
        } // SQLite
    }  // connected
    return result;
}
/** Returns all Runners from event X with sex y. ;-)
@return RunnerList
*/
DBConnection::RunnerList DBConnection::getRunnerListByEventAndSex(int event,runnerObj::SexNum sex) {
    RunnerList result;
    QString querystring;
    if (connected) {
        if (dbtype==SQLite) {
            char **res;
            int nRow,nColumns;
            char *zErrMsg=0;

            sqlite_get_table_printf(db,"select number,surname,forename,birthday,event,team,street,city,plz,nation,chipnum,state,comment,place_total,place_class,place_sex,place_team,place_nation from runner where event = %d AND sex = %d",&res,&nRow,&nColumns,&zErrMsg,event,sex);

            if (nRow > 0) {

                for (int i=(nColumns);i<((nRow+1)*nColumns);i+=nColumns) {
                    result.append( runnerObj(QString(res[i]).toInt(),QString(res[i+1]),QString(res[i+2]),
                                             QString(res[i+3]).toInt(),sex,QString(res[i+4]).toInt(),QString(res[i+5]).toInt(),
                                             QString(res[i+6]),QString(res[i+7]),QString(res[i+8]).toInt(),
                                             QString(res[i+9]),QString(res[i+10]),((runnerObj::StateNum)QString(res[i+11]).toInt()),QString(res[i+12]),
                                             QString(res[i+13]).toInt(),QString(res[i+14]).toInt(),QString(res[i+15]).toInt(),QString(res[i+16]).toInt(),QString(res[i+17]).toInt()));
                }
                sqlite_free_table(res);
            }
        } else {// SQLite
            querystring = QString( "select number,surname,forename,birthday,team,street,city,plz,nation,chipnum,state,comment,place_total,place_class,place_sex,place_team,place_nation from runner where event = '%1' AND sex = '%2' " ).arg( event).arg(sex);
            QSqlQuery query(querystring);
            while(query.next()) {
                result.append(runnerObj(query.value(0).toInt(),query.value(1).toString(),query.value(2).toString(),
                                        query.value(3).toInt(),sex,event,query.value(4).toInt(),
                                        query.value(5).toString(),query.value(6).toString(),query.value(7).toInt(),
                                        query.value(8).toString(),query.value(9).toString(),((runnerObj::StateNum)query.value(10).toInt()),query.value(11).toString(),
                                        query.value(12).toInt(),query.value(13).toInt(),query.value(14).toInt(),query.value(15).toInt(),query.value(16).toInt()   ));
            }// while
        } // else
    } // connect
    return result;
}
/**
@return RunnerTimeList from the event
@param (int event,bool join)
*/
DBConnection::RunnerTimeList DBConnection::getRunnerTimeListByEvent (int event,bool join) {
    QString filter,querystring;
    RunnerTimeList result;
    if (connected) {
        if (dbtype==SQLite) {
            char **res;
            int nRow,nColumns;
            sqlite_get_table_printf(db,"select number,runner,time from runnertimes where event = %d",&res,&nRow,&nColumns,NULL,event);
            if (nRow > 0) {
                for (int i=(nColumns);i<((nRow+1)*nColumns);i+=nColumns) {
                    result.append(runnertimeObj(QString(res[i]).toInt(),event,QString(res[i+1]).toInt(),QString(res[i+2]).toInt()));
                }
                sqlite_free_table(res);
            }
        } else {
            if (join==false) {
                QSqlCursor cursor("runnertimes");
                filter = QString("event = '%1'").arg(event);
                cursor.select(filter);
                while (cursor.next()) {
                    result.append( runnertimeObj(cursor.value("number").toInt(),cursor.value("event").toInt(),cursor.value("runner").toInt(),cursor.value("time").toInt()));
                } // while
            } else { //if join
                querystring = QString("select * from runnertimes");
                QSqlQuery query(querystring);
                while (query.next()) {
                    result.append(runnertimeObj());
                } // while
            } // else
        } // SQLite
    }  // connected
    return result;
}

/**
 list all times from the given event number
@return TimeList
*/
DBConnection::TimeList DBConnection::getTimeListByEvent(int event) {
    QString filter;
    TimeList result;
    if (connected) {
        if (dbtype==SQLite) {
            char **res;
            int nRow,nColumns;
            sqlite_get_table_printf(db,"select number,time from times where event = %d",&res,&nRow,&nColumns,NULL,event);
            if (nRow > 0) {
                for (int i=(nColumns);i<((nRow+1)*nColumns);i+=nColumns) {
                    result.append(timeObj(QString(res[i]).toInt(),event,QTime::fromString(QString(res[i+1]))));
                }
                sqlite_free_table(res);
            }
        } else {
            QSqlCursor cursor("times");
            filter = QString("event = '%1'").arg(event);
            cursor.select(filter);
            while (cursor.next()) {
                result.append(timeObj(cursor.value("number").toInt(),event,QTime::fromString(cursor.value("time").toString())));
            } // while
        } // SQLite
    }  // if

    return result;
}
/** checks if the runnernumber is ok and the runner is stored with the given eventnumber
@param  (int runner,int event)
@return bool
*/
bool DBConnection::checkIfRunnerInEvent (int runner,int event) {
    QString filter;
    bool result=FALSE;
    if (connected) {
        if (dbtype==SQLite) {
            char **res;
            int nRow,nColumns;
            sqlite_get_table_printf(db,"select * from runner where number = %d AND event = %d",&res,&nRow,&nColumns,NULL,runner,event);
            if (nRow > 0) {
                result=TRUE;
                sqlite_free_table(res);
            }
        } else {
            QSqlCursor cursor("runner");
            filter = QString ("number = '%1' AND event = '%2'").arg(runner).arg(event);
            cursor.select(filter);
            if (cursor.next())
                result = TRUE;
            else
                result = FALSE;
        }
    }
    return result;
}

/**  checks if the runner already has a time in this event
@param (int runner,int event)
@return bool
*/
bool DBConnection::checkIfRunnerHasTime(int  runner,int event) {
    QString filter;
    bool result=FALSE;
    if (connected) {
        if (dbtype==SQLite) {
            char **res;
            int nRow,nColumns;
            sqlite_get_table_printf(db,"select * from runnertimes where runner = %d AND event = %d",&res,&nRow,&nColumns,NULL,runner,event);
            if (nRow > 0) {
                result=TRUE;
                sqlite_free_table(res);
            }
        } else {

            QSqlCursor cursor("runnertimes");
            filter = QString("runner = '%1' AND event = '%2'").arg(runner).arg(event);
            cursor.select(filter);
            if (cursor.next())
                result = TRUE;
            else
                result=FALSE;
        }
    }
    return result;
}

/**
 getRunnerByNumber
 @return runnerObj
*/
runnerObj DBConnection::getRunnerByNumber (int number) {
    QString tmp;
    runnerObj result=runnerObj();

    if (connected) {
        if (dbtype==SQLite) {
            char **res;
            int nRow,nColumns;

            sqlite_get_table_printf(db,"select surname,forename,birthday,sex,event,team,street,city,plz,nation,chipnum,state,comment,place_total,place_class,place_sex,place_team,place_nation from runner where number = %d",&res,&nRow,&nColumns,NULL,number);

            if (nRow > 0) {

                for (int i=(nColumns);i<((nRow+1)*nColumns);i+=nColumns) {
                    result= runnerObj(number,QString(res[i]),QString(res[i+1]),
                                      QString(res[i+2]).toInt(),((runnerObj::SexNum)QString(res[i+3]).toInt()),QString(res[i+4]).toInt(),QString(res[i+5]).toInt(),
                                      QString(res[i+6]),QString(res[i+7]),QString(res[i+8]).toInt(),
                                      QString(res[i+9]),QString(res[i+10]),((runnerObj::StateNum)QString(res[i+11]).toInt()),QString(res[i+12]),
                                      QString(res[i+13]).toInt(),QString(res[i+14]).toInt(),QString(res[i+15]).toInt(),QString(res[i+16]).toInt(),QString(res[i+17]).toInt());
                }
                sqlite_free_table(res);
            }
        } else {

            QSqlCursor cursor( "runner" );
            QSqlIndex index = cursor.primaryIndex();
            cursor.setValue( "number", number );
            cursor.select(index,index);
            while ( cursor.next() ) {

                result=runnerObj(cursor.value( "number" ).toInt(),cursor.value( "surname" ).toString(), cursor.value( "forename" ).toString(),
                                 cursor.value( "birthday" ).toInt(),((runnerObj::SexNum)cursor.value( "sex" ).toInt()), cursor.value( "event" ).toInt(),cursor.value( "team" ).toInt(),
                                 cursor.value( "street" ).toString(),cursor.value( "city" ).toString(),cursor.value( "plz" ).toInt(),
                                 cursor.value( "nation" ).toString(),cursor.value( "chipnum" ).toString(),((runnerObj::StateNum)cursor.value( "state" ).toInt()),cursor.value("comment").toString(),
                                 cursor.value("place_total").toInt(),cursor.value("place_class").toInt(),cursor.value("place_sex").toInt(),cursor.value("place_team").toInt(),cursor.value("place_nation").toInt()   ) ;
            }
        }
    }
    return result;
}

/**
getTimeByNumber
@return timeObj
*/
timeObj DBConnection::getTimeByNumber(int number) {
    timeObj result=timeObj();
    if (connected) {
        if (dbtype==SQLite) {
            char **res;
            int nRow,nColumns;
            sqlite_get_table_printf(db,"select event,time from times where number = %d",&res,&nRow,&nColumns,NULL,number);
            if (nRow > 0) {
                for (int i=(nColumns);i<((nRow+1)*nColumns);i+=nColumns) {
                    result= timeObj(number,QString(res[i]).toInt(),QTime::fromString(QString(res[i+1])));
                }
                sqlite_free_table(res);
            }
        } else {
            QSqlCursor cursor("times");
            QSqlIndex index = cursor.primaryIndex();
            cursor.setValue( "number", number );
            cursor.select(index,index);
            while ( cursor.next() ) {
                result=timeObj(cursor.value("number").toInt(),cursor.value("event").toInt(),QTime::fromString(cursor.value("time").toString()));
            }
        }
    }
    return result;
}

QStringList DBConnection::getTeamNameList() {
    QStringList teamList;
    if (connected) {
        if (dbtype==SQLite) {
            char **result;
            int nRow,nColumns;
            sqlite_get_table(db,"select teamname from teams",&result,&nRow,&nColumns,NULL);
            if (nRow > 0) {
                for (int i=(nColumns);i<((nRow+1)*nColumns);i+=nColumns) {
                    teamList.append(QString(result[i]));
                }
                sqlite_free_table(result);
            }
        } else {

            QSqlQuery query( "select teamname from teams" );
            while ( query.next() ) {
                teamList.append( query.value(0).toString());
            }
        }
        teamList.sort();
    }
    return teamList;
}
QStringList DBConnection::getDriverList() {
    driverList = defaultDB->drivers();
    return driverList;
}

DBConnection::EventList DBConnection::getEventList() {
    EventList list;
    if (connected) {
        if (dbtype==SQLite) {
            char **result;
            int nRow,nColumns;

            sqlite_get_table(db,"select * from events",&result,&nRow,&nColumns,NULL);

            if (nRow > 0) {

                for (int i=(nColumns);i<((nRow+1)*nColumns);i+=nColumns) {

                    list.append(eventObj( QString(result[i]).toInt(),QString(result[i+1]),QString(result[i+2]),QTime::fromString(QString(result[i+3])),QString(result[i+5]).toInt()));
                }
                sqlite_free_table(result);
            }
        } else {
            QSqlCursor cursor( "events" );
            cursor.select();
            while ( cursor.next() ) {
                //number int2,event_name text,min_number int2,max_number int2,starttime_0 int4, starttime_1 int4,distance int2)");
                list.append(eventObj(cursor.value( "number" ).toInt(),cursor.value( "eventname" ).toString(), cursor.value( "startnumberframes" ).toString(),
                                     QTime::fromString(cursor.value( "starttime_0" ).toString()), cursor.value( "distance" ).toInt())) ;
            }
        }
    }
    return list;
}

DBConnection::TeamList DBConnection::getTeamList() {
    TeamList list;
    if (connected) {
        if (dbtype==SQLite) {
            char **result;
            int nRow,nColumns;

            sqlite_get_table(db,"select * from teams",&result,&nRow,&nColumns,NULL);
            if (nRow > 0) {
                for (int i=(nColumns);i<((nRow+1)*nColumns);i+=nColumns) {
                    list.append(teamObj( QString(result[i]).toInt(),QString(result[i+1])));
                }
                sqlite_free_table(result);
            }
        } else {
            QSqlCursor cursor("teams");
            cursor.select();
            while (cursor.next() ) {
                list.append(teamObj(cursor.value("number").toInt(),cursor.value("teamname").toString()));
            }
        }

    }
    return list;
}

int DBConnection::getTeamnumberByName (const QString &team) {
    QString filter;
    int result=-1;

    if (connected) {
        if (dbtype==SQLite) {
            char **res;
            int nRow,nColumns;

            sqlite_get_table_printf(db,"select number from teams where teamname = '%q'",&res,&nRow,&nColumns,NULL,team.latin1());
            if (nRow > 0) {

                for (int i=(nColumns);i<((nRow+1)*nColumns);i+=nColumns) {
                    result= QString(res[i]).toInt();
                }
                sqlite_free_table(res);
            }
        } else {
            QSqlCursor cursor( "teams" );
            filter = QString( "teamname = '%1' " ).arg( team );

            //  QSqlIndex index = cursor.index("teamname");
            //    cursor.setValue( "teamname", team );
            cursor.select(filter);
            while ( cursor.next() ) {
                result=cursor.value( "number" ).toInt() ;
            }
        }
    }
    return result;
}

int DBConnection::getEventnumberByName (const QString &event) {
    int result=-1;
    QString filter;
    if (connected) {
        if (dbtype==SQLite) {
            char **res;
            int nRow,nColumns;

            sqlite_get_table_printf(db,"select number from events where eventname = '%q'",&res,&nRow,&nColumns,NULL,event.latin1());
            if (nRow > 0) {
                for (int i=(nColumns);i<((nRow+1)*nColumns);i+=nColumns) {
                    result= QString(res[i]).toInt();
                }
                sqlite_free_table(res);
            }
        } else {
            QSqlCursor cursor( "events" );
            filter = QString( "eventname = '%1' " ).arg( event );
            cursor.select(filter);
            while ( cursor.next() ) {
                result=cursor.value( "number" ).toInt() ;
            }
        }
    }
    return result;
}

/**  deletes a time given by the string and the event number string must be "hh:mm:ss.zzz"
@return TRUE if a time is deleted and FALSE if no time is deleted.
*/
bool DBConnection::deleteTimeByTimestring(const QString & time,int event) {
    QString filter;
    if (connected) {
        if (dbtype==SQLite) {
            sqlite_exec_printf(db, "DELETE FROM times WHERE time = '%q' AND event = %d",  0, 0, 0, time.latin1(),event);
            // number,NULL
            return TRUE;
            //
        } else {
            QSqlCursor cursor("times");
            filter = QString("event = '%1' AND time = '%2'").arg(event).arg(time);
            cursor.select(filter);
            if ( cursor.next() ) {
                cursor.primeDelete();
                if (  cursor.del() == 0 ) {
                    cerr << cursor.lastError().databaseText() << endl;
                    return false;
                }
            }
        } // if
    } // if connected
    return true;
}
/**
@return TRUE if the team is deleted otherwise return FALSE
*/
bool DBConnection::deleteTeamByString(const QString & team) {
    QString filter;
    char *zErrMsg=0;
    if (connected) {
        if (dbtype==SQLite) {
            sqlite_exec_printf(db, "DELETE FROM teams WHERE teamname = '%q'",  0, 0, &zErrMsg, team.latin1());
            // Dangerous operation no constraint here !!
            cerr << zErrMsg << endl;
            return TRUE;
            //
        } else {
            QSqlCursor cursor("teams");
            filter = QString("teamname = '%1'").arg(team);
            cursor.select(filter);
            if ( cursor.next() ) {
                cursor.primeDelete();
                if (  cursor.del() == 0 ) {
                    cerr << cursor.lastError().databaseText() << endl;
                    return false;
                }
            }
        } // if
    } // if connected
    return true;
}

QStringList DBConnection::getEventNameList() {
    QStringList eventList;
    if (connected) {
        if (dbtype==SQLite) {
            char **result;
            int nRow,nColumns;
            sqlite_get_table(db,"select eventname from events",&result,&nRow,&nColumns,NULL);
            if (nRow > 0) {
                for (int i=(nColumns);i<((nRow+1)*nColumns);i+=nColumns) {
                    eventList.append(QString(result[i]));
                }
                sqlite_free_table(result);
            }
        } else {
            QSqlQuery query("select eventname from events");
            while (query.next() ) {
                eventList.append (query.value(0).toString());
            }
        }
        eventList.sort();
    }
    return eventList;
}

QString DBConnection::getDBVersion() {
    QString ver;
    if (connected) {
        if (dbtype==SQLite) {
            ver.append(QString("SQLite Version %1").arg(SQLITE_VERSION));
        } else {
            QSqlQuery query("select version()");
            while (query.next() ) {
                ver.append(query.value(0).toString());
            }
        }

    }
    return ver;
}

QString DBConnection::getCountString(const QString & from) {
    QString count;
    if (connected) {
        if (from.length()<1) return "";
        if (dbtype==SQLite) {
            char **result;
            int nRow,nColumns;
            sqlite_get_table_printf(db,"select COUNT(*) from %q",&result,&nRow,&nColumns,NULL,from.latin1());
            if (nRow > 0) {
                for (int i=(nColumns);i<((nRow+1)*nColumns);i+=nColumns) {
                    count.append(QString(result[i]));
                }
                sqlite_free_table(result);
            }
        } else {
            QSqlQuery query(QString("select COUNT(*) from %1").arg(from));
            while (query.next() ) {
                count.append(query.value(0).toString());
            }
        }
    }
    return count;
}

QString DBConnection::getDatabaseName() {
    if (defaultDB && connected) {
        return defaultDB->databaseName();
    } else if (dbtype==SQLite) {
        return dbname;
    }  else {
        return ("Error while getting Database Name ...");
    }
}

void DBConnection::setCurrentEvent(const QString & name) {
    currentEvent=getEventByName(name);
}

void DBConnection::setCurrentEvent (int event) {
    currentEvent=getEventByNumber(event);
}

eventObj DBConnection::getCurrentEvent() {
    return currentEvent;
}


